#include "jserver.h"

xmlnode js__config = NULL;

int js_config_load(char *file)
{
    char def[] = CONFIGXML;
    char *realfile = (char *)def;
    xmlnode oldcfg = js__config;

    if(file != NULL)
        realfile = file;

    js__config = xmlnode_file(realfile);
    if(js__config == NULL)
    {
        if(oldcfg != NULL)
        { /* only if this was a failed HUP reload */
            js__config = oldcfg;
            log_error("jserver","RE-Configuration using %s failed, using existing config",realfile);
            return 1;
        }

        log_error("jserver","Configuration using %s failed",realfile);
        printf("Configuration using %s failed\n",realfile);
        return 0;
    }

    if(oldcfg != NULL)
    {
        /* XXX do special things here for the new config */
    }

    return 1;
}

xmlnode js_config(char *query)
{
    log_debug(ZONE,"config query %s",query);

    if(query == NULL)
        return js__config;
    else
        return xmlnode_get_tag(js__config, query);
}


struct name_list
{
    char *name;
    struct name_list *next;
};

/* this is a special internal name resolver for the dns name(s) of this transport, to check if a name is local */
int js_config_name(command cmd, char *name)
{
    static struct name_list *names;
    struct name_list *n, *i;
    xmlnode cur;

    log_debug(ZONE,"name %d for %s",cmd,name);

    switch(cmd)
    {
        case C_SET: /* only intended to be run at config/startup time */
            if(js_config_name(C_CHECK,name) || name == NULL)
                return 0;
            n = malloc(sizeof(struct name_list));
            n->name = strdup(name);
            n->next = names;
            names = n;
            break;
        case C_CHECK:
            for(i = names; i != NULL; i = i->next)
                if(j_strcmp(name,i->name) == 0)
                    return 1;
            break;
        case C_INIT:
            for(cur = xmlnode_get_firstchild(js_config("names")); cur != NULL; cur = xmlnode_get_nextsibling(cur))
                if(xmlnode_get_type(cur) == NTYPE_TAG)
                    js_config_name(C_SET,xmlnode_get_data(cur));
            break;
    }
    return 0;
}

