#include "jserver.h"


/* start all system threads here */
void jabber_transport()
{
    xmlnode cur;
    pth_attr_t attr;
    int listen_flag = 0;

    log_debug(ZONE,"JSERVER STARTUP!");

    attr = pth_attr_new();
    pth_attr_set(attr, PTH_ATTR_JOINABLE, FALSE);
    pth_attr_set(attr, PTH_ATTR_STACK_SIZE, etherx_stack_default);

    pth_spawn(attr, js_unknown_main, NULL); /* the thread handling all unknown packets */
    pth_spawn(attr, js_offline_main, NULL); /* the thread handling all offline packets */
    pth_spawn(attr, js_server_main, NULL); /* all traffic to server resources */
    pth_spawn(attr, js_users_main, NULL); /* free cached user data */
/*    pth_spawn(attr, js_debug_main, NULL);*/

    pth_attr_destroy(attr);
    pth_yield(NULL); /* let pth start the threads */


    js_config_name(C_INIT,NULL);

    for(cur = xmlnode_get_firstchild(js_config("listen")); cur != NULL; cur = xmlnode_get_nextsibling(cur))
        if(xmlnode_get_type(cur) == NTYPE_TAG)
        {
            listen_flag = 1;
            js_listen(cur);
        }
    if(!listen_flag)
        js_listen(NULL); /* make sure we start listening even if it wasn't configure */

    js_static(); /* start all the static components */
}


/* start the listen thread(s) based on the configuration */
void js_listen(xmlnode x)
{
    char *ip;
    int port;
 
    ip = xmlnode_get_data(x);
    if(xmlnode_get_attrib(x, "port") == NULL || sscanf(xmlnode_get_attrib(x, "port"), "%d", &port) == 0)
        port = 5222;
 
    if(tlisten_new(port, ip, js_conn_connect, NULL) == NULL)
        log_error("jserver","failed to listen on %s:%d",ip,port);
    else
        log_debug(ZONE,"listening on %s:%d",ip,port);
}
