#ifdef HAVE_OPENSSL
#include "jserver.h"
#include <openssl/evp.h>

mreturn mod_auth_digest(mapi m, void *arg)
{
	EVP_MD_CTX mdctx;
	const EVP_MD *md;
	unsigned char md_value[EVP_MAX_MD_SIZE];
	unsigned char test_value;
	char *concat;
	char *sid;
    char *digest;
	char *passxdb;
	char digest_cmp[42];
	int len, i, md_len;

    if(m->variant != MAPI_VARAUTH) return M_IGNORE;

    log_debug("mod_auth_sha1","checking");

    passxdb = xmlnode_get_data(js_xdb_get(m->user, NS_AUTH));
	digest = xmlnode_get_tag_data(m->packet->iq, "digest");
	sid = xmlnode_get_attrib(m->packet->x, "sid");
	/* Concat the stream id and password */
	/* SHA it up */
	log_debug("mod_auth_sha1", "Got SID: %s", sid);
	len = strlen(passxdb) + strlen(sid);
	concat = malloc(len);
	bzero(concat, len);
	strcat(concat,sid);
	strcat(concat, passxdb);

	SSLeay_add_all_digests();

	md =  EVP_get_digestbyname("sha1");

	EVP_DigestInit(&mdctx, md);
    EVP_DigestUpdate(&mdctx, concat, len);
    EVP_DigestFinal(&mdctx, md_value, &md_len);

	free(concat);

	digest_cmp[42] = '\0';
	snprintf(digest_cmp, 41, 
		"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x", 
		md_value[0],md_value[1],md_value[2],md_value[3],md_value[4],
		md_value[5],md_value[6],md_value[7],md_value[8],md_value[9],
		md_value[10],md_value[11],md_value[12],md_value[13],md_value[14],
		md_value[15],md_value[16],md_value[17],md_value[18],md_value[19],
		md_value[20], md_value[21]);
    log_debug("mod_auth_sha1","comparing %s %s",digest,digest_cmp);

	
    if(digest == NULL || digest_cmp == NULL) return M_PASS;

    if(strcmp(digest, digest_cmp) != 0)
        js_error(m->packet->x, TERROR_AUTH);
    else
        js_iqreply(m->packet->x);

    return M_HANDLED;
}

void mod_auth_sha1(void)
{
    log_debug("mod_auth_sha1","init");
    js_mapi_register(P_OFFLINE, mod_auth_digest, NULL);
}
#else
void mod_auth_sha1(void) {}
#endif
