#include "jserver.h"

/* thread that handles data for other packets, which might be for offline or unknown users */

void *js_offline_main(void *arg)
{
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    mmaster ml;
    mreturn ret;
    udata user;

    log_debug(ZONE,"THREAD:OFFLINE starting");

    mp = pth_msgport_create("js_offline");
    ev = pth_event(PTH_EVENT_MSG,mp);

    ml = js_mapi_master(P_OFFLINE); /* get our offline phase master list */

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            user = (udata)q->p->aux1; /* performace hack, don't lookup the udata again */

            log_debug(ZONE,"THREAD:OFFLINE received %s's packet: %s",user->user,xmlnode2str(q->p->x));

            if(!js_mapi_call(P_OFFLINE, ml->l, q->p, user, NULL, q->p->subtype))
                js_bounce(q->p->x,TERROR_UNAVAIL);

            user->ref--; /* it can be cleaned up now */
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}


