#include "jserver.h"

void *js_server_main(void *arg)
{
    /* thread that handles messages/packets intended for the server
     * - administration
     * - public IQ (agents, etc)
     */
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    mmaster ml;
    mreturn ret;
    
    log_debug(ZONE,"THREAD:SERVER starting");

    mp = pth_msgport_create("js_server");
    ev = pth_event(PTH_EVENT_MSG,mp);

    ml = js_mapi_master(P_SERVER); /* get our server phase master list */

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            log_debug(ZONE,"THREAD:SERVER received a packet: %s",xmlnode2str(q->p->x));

            if(!js_mapi_call(P_SERVER, ml->l, q->p, NULL, NULL, q->p->subtype))
                js_bounce(q->p->x,TERROR_NOTFOUND);
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}


