#include "jserver.h"


sreturn js_service_prescreen(jpacket p)
{
    static mmaster om = NULL;
    udata user;
    char *u, *ul;
    jid test;

    if(om == NULL) om = js_mapi_master(P_OFFLINE);

    if(p == NULL) return S_IGNORE;

    /* enforce the username to lowercase for registration */
    u = xmlnode_get_tag_data(p->iq,"username");
    if(u != NULL)
        for(ul = u;*ul != '\0'; ul++)
            *ul = tolower(*ul);

    test = jid_new(p->p,"test");
    jid_set(test,u,JID_USER);
    if(test->user == NULL)
    {
        js_error(p->x, TERROR_NOTACCEPTABLE);
        return S_BOUNCE;
    }

    if(p->type == JPACKET_IQ && NSCHECK(p->iq,NS_AUTH))
    {
        log_debug(ZONE,"auth request");

        user = js_user(u);
        if(user == NULL)
        { /* no user on this server */
            js_error(p->x, TERROR_AUTH);
        }else{
            if(js_mapi_call(P_OFFLINE, om->l, p, user, NULL, MAPI_VARAUTH))
            { /* someone handled it */
                jpacket_reset(p);
                if(jpacket_subtype(p) == JPACKET__RESULT)
                    return S_AUTHED;
            }else{ /* nobody understood the auth */
                js_error(p->x, TERROR_INTERNAL);
            }
        }
    }else if(p->type == JPACKET_IQ && NSCHECK(p->iq,NS_REGISTER)){
        log_debug(ZONE,"registration request");

        if(!js_mapi_call(P_OFFLINE, om->l, p, NULL, NULL, MAPI_VARREGISTER))
            js_error(p->x, TERROR_NOTIMPL);
    }else{
        js_error(p->x, TERROR_AUTH);
    }

    return S_BOUNCE;
}
