#include "jserver.h"

#define PHASE_INIT 0
#define PHASE_HEAD 1
#define PHASE_BODY 2
#define PHASE_DONE 3

#define MIME_HTML 0
#define MIME_JS 1
#define MIME_XML 2
#define MIME_GIF 3
#define MIME_TXT 4

#define HTTP_MINWAIT 60

/* session ring */
typedef struct hs_struct
{
    session s;
    char *id, *user, *pass;
    int last;
    int timeout;
    struct hs_struct *next, *prev;
} *hs, _hs;

/* http request data */
typedef struct hrq_struct
{
    int phase, clen, rn, re_code, re_flag;
    char *path, *file, *ext;
    char *ip;
    char *buffer;
    hs s;
    jid id;
    thread t;
    xmlnode x, re, q;
    pool p;
} *hrq, _hrq;

void svc_http_qs2xml(xmlnode x, char *qs);
void svc_http_strdecode(char *from);
void svc_http_error(hrq rq, int err);
void svc_http_redirect(hrq rq, char *url);
void svc_http_reply_mime(hrq rq, int type);
void svc_http_reply_append(hrq rq, ...);
void svc_http_reply(hrq rq);

hs svc_http_session(hrq rq);

void svc_http_public_init(void);
void svc_http_public_presence(hrq rq);
void svc_http_public_message(hrq rq);

void svc_http_presence(hrq rq);
void svc_http_message(hrq rq);
void svc_http_roster(hrq rq);
void svc_http_login(hrq rq);
void svc_http_xml(hrq rq);
void svc_http_rpc(hrq rq);
