#include "svc_http.h"

/* HTTP interface for messages
 * getting (GET)
 *   /message.xml?sid
 *   /message.js?sid
 * sending (GET/POST) sid is optional, send anon w/o
 *   /message/to?sid&body&subject&type
 */

void svc_http_message_get(hs s, hrq rq)
{
    /* handle fetching cached messages for a session */
    if(s == NULL)
    {
        /* problem */
    }
}

void svc_http_presence_send(hs s, hrq rq)
{
    /* handle sending messages for a session */
    /* if no sid found, send as a public message */
    if(s == NULL)
    {
        svc_http_public_message(rq);
        return;
    }
}

void svc_http_message(hrq rq)
{
    hs s;

    /* break out depending on the request */
    s = svc_http_session(rq);
    if(rq->file != NULL)
        svc_http_presence_send(s,rq);
    else
        svc_http_presence_get(s,rq);
}
