#include "jserver.h"

/* thread that handles data for other packets, which might be for offline or unknown users */

void *js_unknown_main(void *arg)
{
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    mmaster ml;
    mreturn ret;

    log_debug(ZONE,"THREAD:UNKNOWN starting");

    mp = pth_msgport_create("js_unknown");
    ev = pth_event(PTH_EVENT_MSG,mp);

    ml = js_mapi_master(P_UNKNOWN); /* get our offline phase master list */

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            log_debug(ZONE,"THREAD:UNKNOWN received packet: %s",xmlnode2str(q->p->x));

            if(!js_mapi_call(P_UNKNOWN, ml->l, q->p, NULL, NULL, q->p->subtype))
                js_bounce(q->p->x,TERROR_NOTFOUND);
        }
    }

    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}


